import java.awt.Graphics;
import java.awt.Font;
import java.util.Date;
import java.awt.*;
import java.applet.*;

public class FillCube extends Applet implements Runnable
{
  Graphics offScrGraphics;
  Image offScrImage;
  Thread runner;
  FillVertex[] cubeVertices;
  FillObject cube;
  boolean drawn;

  FillMatrix matrix=new FillMatrix();
  float rotX=(float)0.0;
  float rotY=(float)0.0;
  float rotZ=(float)0.0;
  float scale=(float)0.5;
  float scaleIncrement=(float)0.05;

  int xMidScr;    // screen dimesnion and middle
  int yMidScr;
  int scrWidth;
  int scrHeight;

  public void createPoly()
  {
    cubeVertices=new FillVertex[8];
    for (int i=0;i<8;i++)
      cubeVertices[i]=new FillVertex();

    cubeVertices[0].SetLocal(-10,10,-10);
    cubeVertices[1].SetLocal(10,10,-10);
    cubeVertices[2].SetLocal(10,10,10);
    cubeVertices[3].SetLocal(-10,10,10);
    cubeVertices[4].SetLocal(-10,-10,-10);
    cubeVertices[5].SetLocal(10,-10,-10);
    cubeVertices[6].SetLocal(10,-10,10);
    cubeVertices[7].SetLocal(-10,-10,10);

    cube=new FillObject();
    cube.SetVertices(cubeVertices, 8);

    int polyVert[]=
    {
      0,1,5,4,
      5,6,7,4,
      6,2,3,7,
      2,1,0,3,
      2,6,5,1,
      4,7,3,0
    };

    int polyNumVert[]={4,4,4,4,4,4};
    cube.SetPolygons(polyVert,polyNumVert,6);
    cube.SetGraphics(offScrGraphics, scrWidth, scrHeight,
      xMidScr, yMidScr);
  }

  public void start()
  {
    if (runner==null)
    {
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop()
  {
    if (runner!=null)
    {
      if (runner.isAlive())
        runner.stop();
      runner=null;
    }
  }

  public void run()
  {
	scrWidth=size().width;
	scrHeight=size().height;
	xMidScr=scrWidth/2;    // screen dimesnion and middle
	yMidScr=scrHeight/2;

    offScrImage=createImage(scrWidth,scrHeight);
    offScrGraphics=offScrImage.getGraphics();
    createPoly();

    while (true)
    {
      drawn=false;//flag to avoid bad flicker
      offScrGraphics.setColor(Color.black);
      offScrGraphics.fillRect(0,0,scrWidth,scrHeight);
      rotX+=0.1F;
      rotY+=0.1F;
      rotZ+=0.1F;
      scale+=scaleIncrement;
      if (scale>=scrHeight/30)
        scaleIncrement=-(float)0.05;
      else if (scale<=0.2)
        scaleIncrement=(float)0.05;

      matrix.InitTrans();
      matrix.Scale(scale);
      matrix.Rotate(rotX,rotY,rotZ);
      matrix.Translate(0,0,200);
      cube.Transform(matrix);
      cube.Project(150);
      cube.Draw();

/*      matrix.Translate(20,0,0);
      cube.Transform(matrix);
      cube.Project(150);
      cube.Draw();

      matrix.Translate(-40,0,0);
      cube.Transform(matrix);
      cube.Project(150);
      cube.Draw();*/
      drawn=true;

      repaint();
      try
      {
        Thread.sleep(30);
      }
      catch (InterruptedException e){};
    }
  }


  public void update(Graphics g)
  {
    if (drawn)
    {
      g.drawImage(offScrImage,0,0,this);
    }
  }
}



